#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

char *config_array[][2]={
{ "ip", NULL},
{ "port", NULL}
};

char *config_value_get(char *arg)
{
	int i;
	int config_array_index=sizeof(config_array) / (sizeof(char *) * 2);

	for(i=0 ; i < config_array_index ; i++)
		if(strcmp(arg, config_array[i][0]) == 0)
			return config_array[i][1];

	printf("Error: wrong configuration argument: \"%s\".\n", arg);

	return NULL;
}

void config_value_set(char *arg, char *val)
{
	int i;
	int config_array_index=sizeof(config_array) / (sizeof(char *) * 2);

	for(i=0 ; i < config_array_index ; i++)
		if(strcmp(arg, config_array[i][0]) == 0)
		{
			config_array[i][1]=val;
			return;
		}

	printf("Error: wrong configuration argument: \"%s\".\n", arg);
	free(val);
}

void config_close()
{
	int i;
	int config_array_index=sizeof(config_array) / (sizeof(char *) * 2);

	for(i=0 ; i < config_array_index ; i++)
		free(config_array[i][1]);
}

void config_read(char *config_file)
{
	int config_fd=0;

	char c=0;
	char *arg=NULL;
	char *val=NULL;

	bool arg_lock=true;
	bool val_lock=true;

	int arg_count=0;
	int val_count=0;

	config_fd=open(config_file, O_RDONLY);
	if(config_fd < 0)
	{
		perror("Error while opening configuration");
		exit(1);
	}

	arg=malloc(256);
	memset(arg, 0, 256);

	val=malloc(256);
	memset(val, 0, 256);

	while(read(config_fd, &c, sizeof(char)))
	{
		if(c == '\n')
		{
			if(strcmp(arg, "") == 0 || strcmp(val, "") == 0)
				continue;

			config_value_set(arg, val);

			printf("Config: %s=%s\n", arg, val);

			memset(arg, 0, 256);
			val=malloc(256);
			memset(val, 0, 256);

			arg_lock=true;
			val_lock=true;

			arg_count=0;
			val_count=0;

			continue;
		}
		if(c == '=')
		{
			arg_lock=false;
			continue;
		}
		if((c == ' ' || c == '\t') && (arg_lock || val_lock) || c == '"' || c == '\'')
			continue;

		if(arg_lock)
		{
			arg[arg_count]=c;
			arg_count++;
		}
		else
		{
			if(val_lock)
				val_lock=false;

			val[val_count]=c;
			val_count++;
		}
	}

	close(config_fd);
}

int main(void)
{
	config_read("neoinput.conf");
	printf("arg='%s'\n", config_value_get("ip"));
	config_close();

	return 0;
}

